﻿--
-- About the Script: The cleaning crew washes all your vehicles, which got dirty during the course of the week, in a two-day rythm at midnight hour
--
-- @author:    	BlackSheep-(RC-Devil)
-- @websites:	https://www.farming-mods.de - https://www.mods-community.de
-- @history:	v 1.0.0.0 - 08.03.2017 - Release
--

Cleancrew = {};
addModEventListener(Cleancrew);

function Cleancrew:loadMap(name)
    self.Days = {};
	self.saveconfiguration = true; -- Set this option to false if you do not want automatic save of a Cleancrew_cfg.xml!
	self.count = 0;
	self.newDay = 0;
	-- If the Save Option above, to set false, then enter your working days configuration below.
	-- 0 = No cleaning Day
	-- 15 = Cleaning Day
	self.Days[g_i18n:getText("WorkDay1")] = 15; -- Montag / Monday / Lundi
    self.Days[g_i18n:getText("WorkDay2")] =  0; -- Dienstag / Tuesday / Mardi
    self.Days[g_i18n:getText("WorkDay3")] = 15; -- Mittwoch / Wednesday / Mercredi
    self.Days[g_i18n:getText("WorkDay4")] =  0; -- Donnerstag / Thursday / Jeudi
    self.Days[g_i18n:getText("WorkDay5")] = 15; -- Freitag / Friday / Vendredi
    self.Days[g_i18n:getText("WorkDay6")] =  0; -- Samstag / Saturday / Samedi
    self.Days[g_i18n:getText("WorkDay7")] = 15; -- Sontag / Sunday / Dimanche
    local savegameIndex = g_currentMission.missionInfo.savegameIndex;
	local savegameFolderPath = g_currentMission.missionInfo.savegameDirectory;
		if savegameFolderPath == nil then
			savegameFolderPath = ('%ssavegame%d'):format(getUserProfileAppPath(), savegameIndex);
		end;
    	self.configuration = savegameFolderPath .. '/Cleancrew_cfg.xml';	
	local XMLfile;
		if not fileExists(self.configuration) then
			XMLfile = createXMLFile("Cleancrew_XML", self.configuration, "settings");
		else
			XMLfile = loadXMLFile("Cleancrew_XML", self.configuration, "settings");
		end;
		if XMLfile ~= nil then
			for Weekday = 1,7,1 do
				setXMLInt(XMLfile, "settings."..g_i18n:getText("WorkDay"..Weekday), self.Days[g_i18n:getText("WorkDay"..Weekday)]);
			end;
			saveXMLFile(XMLfile);
		end;
		print("[--- Clean Crew Mod V1.0.0.0 Script loaded by BlackSheep(RC-Devil) Web-Support: https://www.mods-community.de ---]");
	Cleancrew:loadConfiguration();
end;

function Cleancrew:deleteMap()
	if self.saveconfiguration then
		Cleancrew:saveConfiguration()
	end;
end

function Cleancrew:mouseEvent(posX, posY, isDown, isUp, button) end;

function Cleancrew:keyEvent(unicode, sym, modifier, isDown) end;

function Cleancrew:update(dt)
	if g_currentMission.environment.currentDay >= self.newDay then
		if self.count < 0 then 
			local Weekday = g_i18n:getText("WorkDay"..(((g_currentMission.environment.currentDay+6) % 7)+1))
			self.count = math.floor(table.getn(g_currentMission.vehicles) * self.Days[Weekday] / 15 + 0.5);
			if self.Days[Weekday] > 0 and self.count <= 0 then
				self.count = 1;
			end;
		elseif self.count > 0 then
			local needToBeCleaning = nil;
			local dirtyVehicle = -1;
			for k , Vc in pairs(g_currentMission.vehicles) do
				if Vc.getDirtAmount ~= nil then
					if Vc:getDirtAmount() > dirtyVehicle then
						needToBeCleaning = Vc;
						dirtyVehicle = Vc:getDirtAmount();
					end;
				end;
			end;
			if needToBeCleaning ~= nil then
				needToBeCleaning:setDirtAmount(0);
				self.count = self.count - 1;
			end;
		else
			self.count = -1;
			self.newDay = g_currentMission.environment.currentDay + 1;
		end;
	end;
end;

function Cleancrew:draw() end;

function Cleancrew:loadConfiguration()
	local savegameIndex = g_currentMission.missionInfo.savegameIndex;
	local savegameFolderPath = g_currentMission.missionInfo.savegameDirectory;
		if savegameFolderPath == nil then
			savegameFolderPath = ('%ssavegame%d'):format(getUserProfileAppPath(), savegameIndex);
		end;
    	self.configuration = savegameFolderPath .. '/Cleancrew_cfg.xml';
	local XMLfile;
		if fileExists(self.configuration) then
			XMLfile = loadXMLFile("Cleancrew_XML", self.configuration, "settings");
		end;
		if XMLfile ~= nil then
			for Weekday = 1,7,1 do
			self.Days[g_i18n:getText("WorkDay"..Weekday)] = getXMLInt(XMLfile, "settings."..g_i18n:getText("WorkDay"..Weekday));
		end;
	end;	
end;

function Cleancrew:saveConfiguration()
	local savegameIndex = g_currentMission.missionInfo.savegameIndex;
	local savegameFolderPath = g_currentMission.missionInfo.savegameDirectory;
		if savegameFolderPath == nil then
			savegameFolderPath = ('%ssavegame%d'):format(getUserProfileAppPath(), savegameIndex);
		end;
    	self.configuration = savegameFolderPath .. '/Cleancrew_cfg.xml';	
	local XMLfile;
		if not fileExists(self.configuration) then
			XMLfile = createXMLFile("Cleancrew_XML", self.configuration, "settings");
		else
			XMLfile = loadXMLFile("Cleancrew_XML", self.configuration, "settings");
		end;
		if XMLfile ~= nil then
			for Weekday = 1,7,1 do
				setXMLInt(XMLfile, "settings."..g_i18n:getText("WorkDay"..Weekday), self.Days[g_i18n:getText("WorkDay"..Weekday)]);
			end;
		saveXMLFile(XMLfile);
	end;	
end;
